local E = select(2, ...) -- Engine
local CO, L = E:LoadModules("Config", "Locale")

local _
local db
local C = {}

local Index = 80

CO:InitializeOptionsCategory("colors", "Colors", Index)

local function GetOptionsTable_Color(index)
	local color = {
	  name = L[E.PowerTypes[index]] or "Unknown",
	  type = "color",
	  hasAlpha = false,
	  desc = string.format("%s %s", L["Modifies the color of"], L[E.PowerTypes[index]] or "Unknown"),
	  order = index + 100,
	  get = function(info)
			--print(index)
			local c = CO.db.profile.colors.powers[index] or E.PowerColors[index]
			--print(c[1], c[2], c[3], CO.db.profile.colors.powers[index])
			return c[1], c[2], c[3]
	  end,
	  set = function(info, r, g, b)
			if not CO.db.profile.colors.powers[index] then CO.db.profile.colors.powers[index] = {} end
			
			local c = CO.db.profile.colors.powers[index]
			
			c[1], c[2], c[3] = r, g, b
			
			CO.UF:UpdateAllUF()
	  end,
	}

	return color
end

CO.Options.args.colors = {
	name = L["Colors"],
	type = 'group',
	order = Index,
	childGroups = "tab",
	disabled = false,
	args = {
		desc = {
			type = "description",
			order = 1,
			name = "Those settings allow you to override the default resource/power colors. Please be aware that those settings currently don't affect the alternate power bar.",
			fontSize = "small",
		},
		header = {
			type = "header",
			order = 2,
			name = "Resource/Power Colors",
		},
		Mana 			=  GetOptionsTable_Color(0),
		Rage 			=  GetOptionsTable_Color(1),
		Focus 			=  GetOptionsTable_Color(2),
		Energy 			=  GetOptionsTable_Color(3),
		Combopoints 	=  GetOptionsTable_Color(4),
		RunicPower 		=  GetOptionsTable_Color(6),
		HolyPower 		=  GetOptionsTable_Color(9),
		Maelstrom 		=  GetOptionsTable_Color(11),
		Chi 			=  GetOptionsTable_Color(12),
		Insanity 		=  GetOptionsTable_Color(13),
		ArcaneCharges 	=  GetOptionsTable_Color(16),
		Fury 			=  GetOptionsTable_Color(17),
		Pain 			=  GetOptionsTable_Color(18),
		Stagger 		=  GetOptionsTable_Color(30),
	},
	
}

-- Initial callback when the addon is ready (E:OnEnable)
-- It is elemental for this to be designed around update calls that don't need any args !!!
function C:Init()
	db = CO.db.profile.tooltip
end

E:AddSettingsModule(C)