local E = select(2, ...) -- Engine
local CO, L = E:LoadModules("Config", "Locale")

CO.Options.args.global = {
	type = "group",
	name = "Global",
	order = 1,
	args = {
		nameplateHeader = {
			order = 1,
			type = "header",
			name = L["Nameplates"],
		},
		showPlayerNameplate = {
			type = "toggle",
			order = 2,
			name = L["Personal Nameplate"],
			desc = L["Enable/Disable the Blizzard default personal nameplate in the center of the screen"],
			get = function() return CO.db.profile.CVars.nameplateShowSelf end,
			set = function(info, value) CO.db.profile.CVars.nameplateShowSelf = value; SetCVar("nameplateShowSelf", value) end,
		},
		characterHeader = {
			order = 5,
			type = "header",
			name = "Character Panel",
		},
		customStats = {
			type = "toggle",
			order = 6,
			name = "Custom Character Panel",
			desc = "This toggles the custom stat display within the character panel",
			get = function() return CO.db.profile.customStats end,
			set = function(info, value) CO.db.profile.customStats = value; CO:ShowNotification("RELOAD_NOTIFICATION") end,
		},
		worldHeader = {
			order = 10,
			type = "header",
			name = "World Settings",
		},
		worldNameFont = {
		  name = "Name Font",
		  dialogControl = "LSM30_Font",
		  type = "select",
		  desc = "Changes the name font that is being rendered in the WorldFrame [Text above units]\nThis requires a relog, since reloading the UI is not enough for this.\nAlso please note, that not every font will work, as this functionality is heavily dependent on the load order. Just fiddle around a bit.",
		  order = 11,
		  values = CO.AceGUIWidgetLSMlists["font"],
		  get = function(info) return CO.db.profile.global.worldNameFont end,
		  set = function(info, value) CO.db.profile.global.worldNameFont = value end,
		},
		worldDamageFont = {
		  name = "Damage Font",
		  dialogControl = "LSM30_Font",
		  type = "select",
		  desc = "Changes the damage font that is being rendered in the WorldFrame\nThis requires a relog, since reloading the UI is not enough for this.\nAlso please note, that not every font will work, as this functionality is heavily dependent on the load order. Just fiddle around a bit.",
		  order = 12,
		  values = CO.AceGUIWidgetLSMlists["font"],
		  get = function(info) return CO.db.profile.global.worldDamageFont end,
		  set = function(info, value) CO.db.profile.global.worldDamageFont = value end,
		},
		worldDefaultFont = {
		  name = "Default Font",
		  dialogControl = "LSM30_Font",
		  type = "select",
		  desc = "Changes the default font that is being rendered in the WorldFrame. This includes texts like honor gain etc\nThis requires a relog, since reloading the UI is not enough for this.\nAlso please note, that not every font will work, as this functionality is heavily dependent on the load order. Just fiddle around a bit.",
		  order = 13,
		  values = CO.AceGUIWidgetLSMlists["font"],
		  get = function(info) return CO.db.profile.global.worldDefaultFont end,
		  set = function(info, value) CO.db.profile.global.worldDefaultFont = value end,
		},
	},
}