local E = select(2, ...) -- Engine
local CO,L,UF,UAUR,AB = E:LoadModules("Config", "Locale", "Unitframes", "UnitAuras", "Actionbars")
CO.needsInit = false

local _
local DEFAULT_WIDTH, DEFAULT_HEIGHT			= 			890, 650

CO.AC										=			LibStub("AceConfig-3.0")
CO.ACD										=			LibStub("AceConfigDialog-3.0")
CO.Media 									= 			LibStub("LibSharedMedia-3.0")
CO.KB 										= 			LibStub("LibKeyBound-1.0")

CO.AceGUIWidgetLSMlists = {
	['font'] = CO.Media:HashTable("font"),
	['sound'] = CO.Media:HashTable("sound"),
	['statusbar'] = CO.Media:HashTable("statusbar"),
	['border'] = CO.Media:HashTable("border"),
	['background'] = CO.Media:HashTable("background"),
}

-- Define Options table with valid root value --------------------
CO.Options 								= 			{type = "group"}

CO.FontFlags = {
	[""] = "None",
	["OUTLINE"] = "OUTLINE",
	["THICKOUTLINE"] = "THICKOUTLINE",
	["MONOCHROME"] = "MONOCHROME",
}
CO.FontHorizontalAlign = {
	["LEFT"] = L["Left"],
	["CENTER"] = L["Center"],
	["RIGHT"] = L["Right"],
}
CO.FontVerticalAlign = {
	["TOP"] = "Top",
	["MIDDLE"] = "Center",
	["BOTTOM"] = "Bottom",
}

CO.AC:RegisterOptionsTable("CUI", CO.Options)
CO.ACD:SetDefaultSize("CUI", DEFAULT_WIDTH, DEFAULT_HEIGHT)

function CO:ProfileUpdate()
	CO:ShowNotification("RELOAD_NOTIFICATION")
	
	-- @TODO: Update every single module here, so no reload is required anymore.
	--			To do this, we first have to migrate the update methods to the corresponding modules itself.
	--			Currently, they are contained within the config modules.
	--			After that is done, we can even make the options completely separate [Plugin]
end

-- Method to create a new category. This also should be used by plugins!
function CO:InitializeOptionsCategory(TablePath, Name, Order)
	CO.Options.args[TablePath] = {
		type = "group",
		name = Name,
		order = Order,
		args = {},
	}
end

function CO:InitializeSettings()
	CO:SetDefaults() -- Call to external file
	
	CO.db	=	LibStub("AceDB-3.0"):New("CUIDB", E.ConfigDefaults)
	CO.db:RegisterDefaults(E.ConfigDefaults)
	
	CO.db.RegisterCallback(CO, "OnProfileChanged", "ProfileUpdate");
	CO.db.RegisterCallback(CO, "OnProfileCopied", "ProfileUpdate");
	CO.db.RegisterCallback(CO, "OnProfileReset", "ProfileUpdate");
	--self.db.RegisterCallback(self, "OnDatabaseShutdown", "overrideFrames");
	
	CO.Options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(CO.db)
end

function CO:OpenOptions()
	CO.ACD:Open("CUI")
end

function CO:CloseOptions()
	CO.ACD:Close("CUI")
end

function CO:Init()
	L,UF,AB,UAUR = E:LoadModules("Locale", "Unitframes", "Actionbars", "UnitAuras")
	
	CO.AB = AB
	CO.UF = UF
	CO.UAUR = UAUR
	
	CO:InitializeSettings()
end

E:AddModule("Config", CO)