local E = select(2, ...) -- Engine
local CO, L = E:LoadModules("Config", "Locale")

CO.Options.args = {
		CUIVersion = {
			order = 0,
			type = "description",
			name = "|cff1784d1Version: " .. E.Version .."\nUpdated: ".. E.VersionDate .."|r",
			width = "full"
		},
		CUIHeader = {
			order = 1,
			type = "header",
			name = "",
			width = "full",
		},
		LUAErrors = {
			order = 2,
			type = 'toggle',
			name = L["Lua-Errors"],
			desc = L["Show/Hide Lua-Errors. It currently is recommended to hide them!"],
			get = function(info) return CO.db.profile.LUAErrors or false end,
			set = function(info, value) CO.db.profile.LUAErrors = value end,
		},
		KeybindSetup = {
			order = 3,
			type = 'execute',
			name = L["SetKeybinds"],
			--name = "[Coming Soon]",
			func = function() CO.KB:Toggle(); CO:CloseOptions(); GameTooltip:Hide() end,
			--disabled = true,
		},
		Install = {
			order = 4,
			type = 'execute',
			name = L["Install"] .. " [TBD]",
			desc = L["Install everything"],
			func = function() E:print("This will trigger the installation!") end,
			disabled = true,
		},
		ToggleAnchors = {
			order = 5,
			type = "execute",
			name = L["Toggle Anchors"],
			desc = L["Unlock various elements of the UI to reposition them."],
			func = function() CO:CloseOptions(); CO.AB:UpdateBarHandles(); E:ToggleMover(true); CO:ShowNotification("HANDLE_MOVE_NOTIFICATION"); CO:ToggleMoveGrid(); GameTooltip:Hide() end,
		},
		ResetAllMovers = {
			order = 6,
			type = "execute",
			name = L["Reset Anchors"],
			desc = L["Reset all frames to their original positions."],
			func = function() CO:ShowNotification("RESET_ANCHORS") end,
		},
}