local E = select(2, ...) -- Engine
local CO = E:LoadModules("Config")

function CO:ShowNotification(type)
	if CurrentShownNotification ~= type then
		StaticPopup_Show(type)
		CurrentShownNotification = type
	end
end

	StaticPopupDialogs["FONT_TYPE_NOTIFICATION"] = {
	  text = "The modifications you made, may not apply to every font type or just after the tooltip has been shown a few times!",
	  button1 = "OK",
	  OnAccept = function() CurrentShownNotification = nil end,
	  OnCancel = function() CurrentShownNotification = nil end,
	  timeout = 0,
	  whileDead = true,
	  hideOnEscape = true,
	  preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
	}
	StaticPopupDialogs["RELOAD_NOTIFICATION"] = {
	  text = "The modifications you made, may not apply until your UI has been reloaded!",
	  button1 = "OK",
	  button2 = "Cancel",
	  OnAccept = function() ReloadUI(); CurrentShownNotification = nil end,
	  OnCancel = function() CurrentShownNotification = nil end,
	  timeout = 0,
	  whileDead = true,
	  hideOnEscape = true,
	  preferredIndex = 3,
	}
	StaticPopupDialogs["HANDLE_MOVE_NOTIFICATION"] = {
	  text = "The frames are now movable. To lock them, click the button below.",
	  button1 = "Lock",
	  OnAccept = function() CO.AB:UpdateBarHandles("disable"); CO.ACD:Open("CUI"); CO:ToggleMoveGrid(); E:ToggleMover(false); CurrentShownNotification = type end,
	  timeout = 0,
	  whileDead = true,
	  hideOnEscape = false,
	  preferredIndex = 10,
	}
	StaticPopupDialogs["CLEAR_ACTIONBARS_NOTIFICATION"] = {
	  text = "You are about to empty ALL your actionbars ENTIRELY. Are you absolutely sure, you want to perform this action?",
	  button1 = "Yes",
	  button2 = "Cancel",
	  OnAccept = function() CurrentShownNotification = nil CO:ShowNotification("CLEAR_ACTIONBARS_NOTIFICATION2"); end,
	  OnCancel = function() CurrentShownNotification = nil end,
	  timeout = 15,
	  whileDead = true,
	  hideOnEscape = true,
	  preferredIndex = 3,
	}
	StaticPopupDialogs["CLEAR_ACTIONBARS_NOTIFICATION2"] = {
	  text = "This action cannot be reversed. Are you sure?",
	  button1 = "Clear all Bars",
	  button2 = "Cancel",
	  OnAccept = function() for i = 1,120 do PickupAction(i) ClearCursor() end; CurrentShownNotification = nil end,
	  OnCancel = function() CurrentShownNotification = nil end,
	  timeout = 5,
	  whileDead = true,
	  hideOnEscape = true,
	  preferredIndex = 3,
	}
	StaticPopupDialogs["KEYREBIND_ACTIVE"] = {
	  text = "Key rebind enabled. You can now hover actionslots and press desired keys to assign. Use ESC to remove the current bind from the slot.",
	  button1 = "Lock",
	  OnAccept = function() CO.AB:SetKeybinder(false); ACD:Open("CUI"); CurrentShownNotification = nil end,
	  timeout = 0,
	  whileDead = true,
	  hideOnEscape = false,
	  preferredIndex = 10,
	}
	StaticPopupDialogs["RESET_ANCHORS"] = {
	  text = "Are you sure you want to reset all anchors to their default position?",
	  button1 = "Reset Anchors",
	  button2 = "Cancel",
	  OnAccept = function() E:ResetMoverPositions(); CurrentShownNotification = nil; end,
	  OnCancel = function() CurrentShownNotification = nil end,
	  timeout = 0,
	  whileDead = true,
	  hideOnEscape = true,
	  preferredIndex = 10,
	}