local E = select(2, ...) -- Engine
local CO = E:LoadModules("Config")

local Content071 = [[|cff1784d1- Fixed GameTooltip anchoring
- Every single tooltip now should be stylized
- Fixed an issue that caused Lua-Errors when changing keybinds
- Fixed an issue that caused the azerite bar to throw an error after a UI load for some players
|r]]

local Content070 = [[|cff1784d1- Added castbar spark
- Fixed laggy castbar progress
- Added cast-delay functionality to castbars
- Improved Unit Dummy mode
- Added vehicle exit button
- Fixed memory issues when opening the worldmap with the CUI marker plugin enabled
- Fixed memory issues with retrieving coordinates and bumped up the update frequency again
- Readycheck indicators
- Resurrect indicators
- Added some entrance markers
- Added duration animation to auras
- Fixed some issues regarding the castbar
- Added power coloring options
- Added background for the alternate power bar
- Added azerite bar (static for now just as the xp bar)
- Fixed an issue that caused item tooltips to have a white background
|r]]
local Content060 = [[|cff1784d1- Added new aura system and several initial options
- Added mover for the general info frame
- Added reputation bar (Hides when no faction is watched. Options to come)
- Added honor bar (Set Visibility: H -> Right-Click the honor icon on the right hand side -> Set as XP-bar)
- Added key-rebinder to stancebar and extra actionbutton
- Changed the tooltip style system so it allows full flexibility in how each tooltip type is styled. There will be options to configure each style soon
- Fixed spell-flash for macros

[Cosmetic changes]
- Styled minimap tracking icon and moved instance difficulty to the left
- Styled minimap clock
- Added combat indicator for player
- Changed XP-bar to behave just like the vanilla one
- Changed unitframe tooltips to behave like the vanilla ones
|r]]
local Content052 = [[|cff1784d1- Fixed castbar interruptor display
|r]]
local Content051 = [[|cff1784d1- Fixed an issue with mover repositioning
- Fixed some Lua-Errors
|r]]
local Content050 = [[|cff1784d1- Changed entire file structure and splitted up functionality of several modules
- Updated defaults to make the vehicle seat frame fit. Also fixed Objective Tracker position
- Added option to reset all anchors to their default position
- Added totem bar! [Options to come. It's movable tho, okay?]
- Full transition to the BfA API changes
- Added aura and castbar-icon borders (color driven by the player class. For castbars, color is determined by wether the spell is interruptible)
- Added tooltip borders for units, spells, auras and items (macros and pets still missing)
- Decreased coordinates update frequency to compensate a memory leak issue in the new BfA map API. It is still present, but should generate 70% less memory now
- Added mouseover highlight for auras
- Fixed castbar spellname offset
- Changed Unit maxlevel to 120. BfA is coming, baby!
|r]]
local Content042 = [[|cff1784d1- Changed actionbutton behaviour to react to the locked actionbar setting
|r]]
local Content040 = [[|cff1784d1- Added option so sort unitframe clusters and change the X and Y gap between each frame
- Added tooltip information for units to display its current target and who in your raid has this unit as a target
- Added a metric heck-ton of options for the unitframes and moved some of them to a better place!
- Changed a lot of the settings descriptions to make clear what they do
- Changed maximum value of the Head Tracking Strength to the appropiate maximum possible
|r]]
local Content030 = [[|cff1784d1- Tons of bugs have been fixed!
- New default minimap style and scaling option.
- Overhauled the screen textures and replaced them with some sleak and simple ones!
- Added aura bars!
- Changed the look of the chat input box and added a basic channel switch functionality via tab-key!
- Added several new movers for default blizzard frames
- Added option to toggle unitframe portraits
- Added new 'engine' settings to fiddle around with the camera speed and the actioncam
- Added a unit-dummy mode (accessible via Unitframes > Dummy Mode) for later re-ordering of unitframe groups!
- Added options to move the unitframe powerbar
- Added options to scale individual unitframes and their powerbars
- Completely rewritten unitframes module for later possible unitframe creation on the fly
- Added the interruptor name to the castbar interrupt text
- Added pet actionbar
- Fixed vanilla party and bossframe sometimes showing up
- Added AddOn compability for both, Legion AND BfA. The system will now correctly respond to the API changes automatically!
- Added visibility condition option for actionbars
- The UI now reacts to petbattles and hides certain frames when neccessary
- Added tooltip and aurabar options
- Changed default frame positions a bit
- Fixed actionbars once and for all
- Fixed mover issues with the alternate power bar
- Fixed castbar not working correctly for channel casts
- Added state driver for the alternate power bar. It now will automatically hide if it does not contain your primary resource!
- Added temporary fix for deathknight runes. Still needs better solution, since this one eats too much CPU time
- Overhauled the actionbar system again. It now reacts to binding/hotkey updates
- Added 3 optional actionbars [With a little warning text in the options. That problem caused me headaches in the past, as i set up ElvUI with extra bars]
- Added Hot-Key reassign mode!
- Stylized player tooltips
- Applied various optimizations to the AddOn engine and its modules
- Added role overview for party and raid
|r]]
local Content020 = [[|cff1784d1- Added custom castbars for the main units (player, target and focus)
- Fixed Aura display
- Fixed option for personal nameplate to take effect on profile creation (and first login)
- Fixed micromenu icons\n- Added player aura movers
- Added questtracker mover
- Added chat mover\n- Fixed default profile issues due to missing mover data
- Added a color based status for FPS and Latency
- Added a new Stat-icon layout and initial values for the character-frame (will be optional soon)
- Updated default profile and added 3 new internal statusbar textures!
|r]]
local Content011 = [[|cff1784d1- Added new frame mover system. This now allows you to reposition unitframes!
- Added locale system and english+german as initially supported languages! (We need translators :3)
- Added XP-bar tooltip
- Added missing casttime to castbar
- Added mouseover highlight for unitframes!
|r]]
local Content010 = [[|cff1784d1- Overhauled internal variables to use a different approach in OOP
- Added visual anchor grid
- Added various functionality
- Fixed Warlock Soul Shard bar
- Fixed occuring LUA-Errors for MainBarFrame
- Fixed tons of taint issues (there are basically none left now)
- Fixed display of location coordinates (Blizzard likes to change API things lately)
- Added internal option to toggle the personal resource bar (The thing below your character in the middle of the screen)
- Added rested bar to XP bar
- Added Masque support!
- Fixed an issue that caused the stancebar to be displayed on classes that don't have any shapeshifting
- Added credits and changelog to the options panel
|r]]

CO.Options.args.changelog = {
	type = "group",
	name = "Changelog",
	order = 500,
	args = {
		Header_071 = {
			order = 5977,
			type = "header",
			name = "Minor - 0.7.1 Release [August 20th 2018]",
		},
		Content_071 = {
			order = 5978,
			type = "description",
			name = Content071,
			fontSize = "medium",
		},
		Header_070 = {
			order = 5979,
			type = "header",
			name = "Major - 0.7.0 Release [August 18th 2018]",
		},
		Content_070 = {
			order = 5980,
			type = "description",
			name = Content070,
			fontSize = "medium",
		},
		Header_060 = {
			order = 5981,
			type = "header",
			name = "Major - 0.6.0 Release [July 23rd 2018]",
		},
		Content_060 = {
			order = 5982,
			type = "description",
			name = Content060,
			fontSize = "medium",
		},
		Header_052 = {
			order = 5983,
			type = "header",
			name = "Minor - 0.5.2 Release [July 19th 2018]",
		},
		Content_052 = {
			order = 5984,
			type = "description",
			name = Content052,
			fontSize = "medium",
		},
		Header_051 = {
			order = 5985,
			type = "header",
			name = "Minor - 0.5.1 Release [July 18th 2018]",
		},
		Content_051 = {
			order = 5986,
			type = "description",
			name = Content051,
			fontSize = "medium",
		},
		Header_050 = {
			order = 5987,
			type = "header",
			name = "Major - 0.5.0 Release [July 18th 2018]",
		},
		Content_050 = {
			order = 5988,
			type = "description",
			name = Content050,
			fontSize = "medium",
		},
		Header_042 = {
			order = 5989,
			type = "header",
			name = "Minor - 0.4.2 Release [July 4th 2018]",
		},
		Content_042 = {
			order = 5990,
			type = "description",
			name = Content042,
			fontSize = "medium",
		},
		Header_040 = {
			order = 5991,
			type = "header",
			name = "Major - 0.4.0 Release [July 2st 2018]",
		},
		Content_040 = {
			order = 5992,
			type = "description",
			name = Content040,
			fontSize = "medium",
		},
		Header_030 = {
			order = 5993,
			type = "header",
			name = "Major - 0.3.0 Release [June 20th 2018]",
		},
		Content_030 = {
			order = 5994,
			type = "description",
			name = Content030,
			fontSize = "medium",
		},
		Header_020 = {
			order = 5995,
			type = "header",
			name = "Major - 0.2.0 B [May 12th 2018]",
		},
		Content_020 = {
			order = 5996,
			type = "description",
			name = Content020,
			fontSize = "medium",
		},
		Header_011 = {
			order = 5997,
			type = "header",
			name = "Minor - 0.1.1 B [May 10th 2018]",
		},
		Content_011 = {
			order = 5998,
			type = "description",
			name = Content011,
			fontSize = "medium",
		},
		Header_010 = {
			order = 5999,
			type = "header",
			name = "Major - 0.1.0 B [May 9th 2018]",
		},
		Content_010 = {
			order = 6000,
			type = "description",
			name = Content010,
			fontSize = "medium",
		},
	},
}