local E = select(2, ...) -- Engine
local CO,LOC,LT,UF,TT,BH = E:LoadModules("Config", "Locale", "Layout", "Unitframes", "Tooltip", "Bar_Honor")

local _
local format					= string.format
local IsWatchingHonorAsXP		= IsWatchingHonorAsXP
local UnitHonor					= UnitHonor
local UnitHonor					= UnitHonor

local Texture = [[Interface\AddOns\CUI\Textures\statusbar\layoutBarBottom]]
local TextureReversed = [[Interface\AddOns\CUI\Textures\statusbar\layoutBarBottomReversed]]

BH.E = CreateFrame("Frame")
BH.UpdateData = {}

function BH:UpdateHonorData()
	self.UpdateData.CurrentHonor 	= UnitHonor("player")
	self.UpdateData.MaxHonor 		= UnitHonorMax("player")
end

function BH:UpdateValue()
	self.Bar.Overlay:SetMinMaxValues(0, self.UpdateData.MaxHonor)
	self.Bar.Overlay:SetValue(self.UpdateData.CurrentHonor)
end

function BH:Update()
	self:UpdateHonorData()
	self:UpdateValue()
end

local function UpdateVisibility(CVar)
	if CVar and CVar ~= "showHonorAsExperience" then return end
	
	BH.IsVisible = IsWatchingHonorAsXP()
	
	if BH.IsVisible then
		BH.Bar:Show()
	else
		BH.Bar:Hide()
	end
end

function BH:__Construct()
	self.Bar = UF:CreateBar("CUI_HonorBar", "MEDIUM", 256, 32, nil, nil, true, false, false)
	self.Bar:SetParent(E.Parent)
	self.Bar:SetPoint("BOTTOMLEFT", E.Parent, "BOTTOMLEFT", 0, 15)
	
	self.Bar.Overlay:SetStatusBarTexture(TextureReversed)
	self.Bar.Background.Tex:SetTexture(TextureReversed)
	
	self.Bar.Background.Tex:SetVertexColor(0.3, 0.3, 0.3, 0.7)
	
	self.Bar.Overlay:SetStatusBarColor(1, 0.4, 0.4, 1)
	self.Bar.Overlay:SetAttribute("ReceivesGlobalTexture", false)
	self.Bar.Border:Hide()
	
	self.Bar.Button = CreateFrame("Button", "CUI_HonorBarButton", self.Bar.Overlay)
	self.Bar.Button:SetAllPoints(self.Bar.Overlay)
	
	self.Bar.Button:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		
		GameTooltip:AddLine(HONOR)
		GameTooltip:AddLine(format("%s / %s", BH.UpdateData.CurrentHonor, BH.UpdateData.MaxHonor))
		
		TT:UpdateStyle(nil)
		
		GameTooltip:Show()
	end)
	self.Bar.Button:SetScript("OnLeave", function(self)
		GameTooltip:Hide()
	end)
	
	-- "We could push an update via CVAR_UPDATE"
	-- "No, that would be too easy, dude"
	-- "Let's just set that CVar silently"
	-- 11/10, gg
	hooksecurefunc("SetCVar", UpdateVisibility)
	
	self.E:RegisterEvent("PLAYER_ENTERING_WORLD")
	self.E:RegisterEvent("HONOR_XP_UPDATE")
	self.E:SetScript("OnEvent", function(self, event, ...)		
		BH:Update()
	end)
	
	UpdateVisibility()
end

function BH:Init()
	self:__Construct()
end

E:AddModule("Bar_Honor", BH)