local E = select(2, ...) -- Engine
local CO,LOC,LT,UF,TT,BR = E:LoadModules("Config", "Locale", "Layout", "Unitframes", "Tooltip", "Bar_Reputation")

local _
local format		= string.format

local Texture = [[Interface\AddOns\CUI\Textures\statusbar\layoutBarBottom]]
local TextureReversed = [[Interface\AddOns\CUI\Textures\statusbar\layoutBarBottomReversed]]

BR.E = CreateFrame("Frame")
BR.UpdateData = {}

function BR:UpdateFactionData()

	self.UpdateData.Name, _, self.UpdateData.MinValue, self.UpdateData.MaxValue, self.UpdateData.CurrentValue, _ = GetWatchedFactionInfo()

	if self.UpdateData.Name then
		if self.UpdateData.CurrentValue >= 0 then
			self.UpdateData.CurrentValue = self.UpdateData.CurrentValue - self.UpdateData.MinValue
			self.UpdateData.MaxValue = self.UpdateData.MaxValue - self.UpdateData.MinValue
			self.UpdateData.MinValue = 0
			
			self.UpdateData.IsHostile = false
		else
			self.UpdateData.CurrentValue = self.UpdateData.CurrentValue * (-1)
			self.UpdateData.MaxValue = self.UpdateData.MaxValue * (-1)
			self.UpdateData.MinValue = self.UpdateData.MinValue * (-1)
			
			self.UpdateData.CurrentValue = (self.UpdateData.MinValue - (self.UpdateData.CurrentValue - self.UpdateData.MaxValue)) - self.UpdateData.MaxValue
			self.UpdateData.MaxValue = self.UpdateData.MinValue - self.UpdateData.MaxValue
			self.UpdateData.MinValue = 0
			
			self.UpdateData.IsHostile = true
		end
	end
end

function BR:UpdateValue()
	if self.UpdateData.Name then
		self.Bar.Overlay:SetMinMaxValues(self.UpdateData.MinValue, self.UpdateData.MaxValue)
		self.Bar.Overlay:SetValue(self.UpdateData.CurrentValue)
		
		self.Bar:Show()
	else
		self.Bar:Hide()
	end
end

function BR:UpdateColor()
	if self.UpdateData.IsHostile then
		self.Bar.Overlay:SetStatusBarColor(0.7, 0.15, 0.15, 1)
		--self.Bar.Border.UpdateBorderColor(0.6, 0.1, 0.1, 0.5)
	else
		self.Bar.Overlay:SetStatusBarColor(0.7, 0.7, 0.7, 1)
		--self.Bar.Border.UpdateBorderColor(0.1, 0.1, 0.1, 0.9)
	end
end

function BR:__Construct()
	self.Bar = UF:CreateBar("CUI_ReputationBar", "MEDIUM", 256, 32, nil, nil, true, false, false)
	self.Bar:SetParent(E.Parent)
	self.Bar:SetPoint("BOTTOMRIGHT", E.Parent, "BOTTOMRIGHT", 0, 15)
	
	self.Bar.Overlay:SetStatusBarTexture(Texture)
	self.Bar.Background.Tex:SetTexture(Texture)
	
	self.Bar.Background.Tex:SetVertexColor(0.3, 0.3, 0.3, 0.7)
	
	self.Bar.Overlay:SetAttribute("ReceivesGlobalTexture", false)
	self.Bar.Border:Hide()
	
	self.Bar.Overlay:SetAttribute("ReceivesGlobalTexture", false)
	
	self.Bar.Button = CreateFrame("Button", "CUI_ReputationBarButton", self.Bar.Overlay)
	self.Bar.Button:SetAllPoints(self.Bar.Overlay)
	
	self.Bar.Button:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		
		GameTooltip:AddLine(BR.UpdateData.Name)
		GameTooltip:AddLine(format("%s / %s", BR.UpdateData.CurrentValue, BR.UpdateData.MaxValue))
		
		TT:UpdateStyle(nil)
		
		GameTooltip:Show()
	end)
	self.Bar.Button:SetScript("OnLeave", function(self)
		GameTooltip:Hide()
	end)
	
	self.E:RegisterEvent("PLAYER_ENTERING_WORLD")
	self.E:RegisterEvent("UPDATE_FACTION")
	self.E:SetScript("OnEvent", function(self, event, ...)
		BR:UpdateFactionData()
		BR:UpdateColor()
		BR:UpdateValue()
	end)
end

function BR:Init()
	self:__Construct()
end

E:AddModule("Bar_Reputation", BR)