local E = select(2, ...) -- Engine
local CO,LOC,UF,AB,LT,AUR,TT,MM = E:LoadModules("Config", "Locale", "Unitframes", "Actionbars", "Layout", "Auras", "Tooltip", "Minimap")

local _
MM.E = CreateFrame("Frame") -- Event

local CUI_MinimapBorder, CUI_MinimapBackground
local FramesToHide = {MinimapBorder, MinimapBorderTop, MinimapZoomIn, MinimapZoomOut}
local QuetMode = false
local MINIMAP_MASK_TEXTURE, MINIMAP_BORDER_TEXTURE, MINIMAP_BACKGROUND_TEXTURE, MINIMAP_PLAYERICON_TEXTURE

	MINIMAP_MASK_TEXTURE = [[Interface\AddOns\CUI\Textures\minimap\maskModern]]
	MINIMAP_BORDER_TEXTURE = [[Interface\AddOns\CUI\Textures\minimap\borderModern]]
	MINIMAP_BACKGROUND_TEXTURE = [[Interface\AddOns\CUI\Textures\minimap\background]]
	MINIMAP_PLAYERICON_TEXTURE = [[Interface\AddOns\CUI\Textures\minimap\playerIcon]]
	
--local GetMinimapShape = GetMinimapShape

	
do
	--if select(3, UnitClass("player")) == 11 then 
	if UnitName("player") == "Arenima" then
		-- QuetMode = true
	end
end

function MM:LoadMinimapStyle()
	local Update = function(Object, Size, Texture, TextureCoord)
		Object = Minimap:CreateTexture(nil)
		Object:ClearAllPoints()
		Object:SetPoint("CENTER", Minimap, "CENTER", 0, 0)
		Object:SetSize(Size,Size)
		Object:SetTexture(Texture)
		Object:SetTexCoord(TextureCoord[1],TextureCoord[2],TextureCoord[3],TextureCoord[4])
	end
	local Frames = {
		["CUI_MinimapBorder"] 		= {140, MINIMAP_BORDER_TEXTURE, {0,1,0,1}},
		-- ["CUI_MinimapBackground"] 	= {140, MINIMAP_BACKGROUND_TEXTURE, {0,1,0,1}},
	}
	for k,v in pairs(Frames) do
		Update(k, v[1],v[2],v[3])
	end
	
	local Mover = E:CreateMover(MinimapCluster, "Minimap", "TOPRIGHT")
	E:RepositionMover(Mover, "TOPRIGHT", 0, 0)
	
	Minimap:SetMaskTexture(MINIMAP_MASK_TEXTURE)
	
	MM:EnableMouseZoom()
	MM:HideBlizzard()
	
	if QuetMode == true then Minimap:SetPlayerTexture(MINIMAP_PLAYERICON_TEXTURE) end
end

function MM:HideBlizzard()
	for k,v in pairs(FramesToHide) do
		v:Hide()
	end
end

function MM:EnableMouseZoom()
	Minimap:EnableMouseWheel(true)
	Minimap:SetScript('OnMouseWheel', function(self, delta)
		if delta > 0 then
			Minimap_ZoomIn()
		else
			Minimap_ZoomOut() 
		end
	end)
end

function MM:StyleButtons()
	local TrackingButtonName = "MiniMapTracking"
	
	--_G[TrackingButtonName .. "Background"]:Hide()
	_G[TrackingButtonName .. "ButtonBorder"]:Hide()
	
	_G[TrackingButtonName]:ClearAllPoints()
	_G[TrackingButtonName]:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 1, 2)
	
	_G[TrackingButtonName .. "Background"]:SetTexture([[Interface\AddOns\CUI\Textures\icons\minimap\IconBackground]])
	_G[TrackingButtonName .. "Background"]:SetVertexColor(0.5, 0.5, 0.5, 1)
	
	_G[TrackingButtonName .. "Button"]:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self)
		GameTooltip:AddLine("|cff1784d1" .. TRACKING .. "|r")
		GameTooltip:AddLine(MINIMAP_TRACKING_TOOLTIP_NONE)
		
		GameTooltip:Show()
	end)
	
	MM:HandleClock()
	MM:HandleDifficulty()
end

function MM:HandleDifficulty()
	local Diff = "MiniMapInstanceDifficulty"
	
	_G[Diff]:ClearAllPoints()
	_G[Diff]:SetPoint("LEFT", Minimap, "LEFT", -(_G[Diff]:GetWidth() / 2), 0)
end

function MM:HandleClock()
	-- We simply cannot access the border texture. Damn.
	local Clock = "TimeManagerClockButton"
	_G[Clock]:SetScript("OnShow", function(self) self:Hide() end)
	_G[Clock]:Hide()
	
	local ClockFrame = CreateFrame("Button", "CUI_ClockFrame", Minimap)
	ClockFrame:SetPoint("BOTTOM", Minimap, "BOTTOM", 0, 5)
	ClockFrame:SetSize(50, 10)
	
	ClockFrame:EnableMouse(true)
	ClockFrame:RegisterForClicks("AnyUp")
	
	ClockFrame:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self)
		TimeManagerClockButton_UpdateTooltip()
	end)
	ClockFrame:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	ClockFrame:SetScript("OnClick", _G[Clock]:GetScript("OnClick"))
	
	ClockFrame.Time = ClockFrame:CreateFontString(nil)
	E:InitializeFontFrame(ClockFrame.Time, "OVERLAY", "FRIZQT__.TTF", 10, {1,1,1}, 1, {0,0}, "", 0, 0, ClockFrame, "CENTER", {1,1})
	
	ClockFrame.updateTimer = 0
	ClockFrame:SetScript("OnUpdate", function(self, elapsed)
		self.updateTimer = self.updateTimer + elapsed
		
		if self.updateTimer >= 1 then
			self.Time:SetText(GameTime_GetTime(GetCVar("timeMgrUseMilitaryTime")))
			
			self.updateTimer = 0
		end
	end)
end

-- Causes the minimap buttons to correctly follow the new shape
-- We simply override the function global c:
--GetMinimapShape = function() return "CORNER-BOTTOMLEFT" end
GetMinimapShape = function() return "SQUARE" end

function MM:Init()
	CO = E:GetModule("Config")
	MM:LoadMinimapStyle()
	
	Minimap:SetArchBlobRingScalar(0)
	Minimap:SetQuestBlobRingScalar(0)
	
	self:StyleButtons()
	
	self.E:RegisterEvent("ADDON_LOADED")
	self.E:SetScript("OnEvent", function(self, event, ...)
		
	end)
end

E:AddModule("Minimap", MM)